/**
 * Copyright (c) 2021 Dominic Masters
 * 
 * This software is released under the MIT License.
 * https://opensource.org/licenses/MIT
 */

#pragma once
#include "../libs.h"
#include "vntextbox.h"

#define VN_CONVERSATION_TEXT_COUNT_MAX 32

#define VN_CONVERSATION_TYPE_DELAY 0x01
#define VN_CONVERSATION_TYPE_TEXT 0x02

typedef struct {
  /** Conversation Type to decide what this data is used for */
  uint8_t type;

  /** Pointer to the string for text to display */
  char *text;

  /** Time in seconds to delay if type is delay */
  float delay;
} vnconversationtext_t;

typedef struct {
  vntextbox_t textbox;
  vnconversationtext_t texts[VN_CONVERSATION_TEXT_COUNT_MAX];

  float timeline;
  float delayStart;

  uint8_t textCount;
  uint8_t textCurrent;
} vnconversation_t;